#ifndef JOGO_H
#define JOGO_H

//// Pr-Processador
//
#define TAM_NOME_JOGADOR (20+1)
	// input
#define MAX_ACCOES_PENDENTES (8)	// se alguem conseguir carregar em mais de 8 teclas entre cada update eu kero conhecer esse cromo (talvez algum japones maluco)
	// Snake
#define TAMANHO_SNAKE_INICIAL (4)
#define DISTANCIA_ENTRE_ELEMENTOS_SNAKE (21) // distancia minima entre cada elemento da cobra (por exemplo: entre a cabea e um elemento do corpo)
#define GROSSURA_COBRA (20)			// o nome diz tudo
#define UNIDADES_A_CRESCER (2)		// unidades que a cobra cresce kd come kk coisa
	// Alimento
#define GROSSURA_ALIMENTO (14)		// o nome diz tudo
#define PROB_ALIMENTO_FRACO (25)	// em percentagem
#define PROB_ALIMENTO_MEDIO (50)	// em percentagem
#define PROB_ALIMENTO_BRUTO (25)	// em percentagem
#define PONTOS_POR_ALIMENTO (10)	// usado nos Scores (o fraco  metade e o bruto o quadruplo)
	// Dimensoes do mundo
#define LARGURA_MUNDO (986)
#define ALTURA_MUNDO (650)
	// FPS
#define FPS_NORMAL (8)
#define FPS_HARD (18)

//// Prototipos de Funes
//

//// Tipos de Dados
//

typedef enum { NORTE = 0, SUL, ESTE, OESTE } DIRECCAO_COBRA;
typedef enum { NORMAL = 1, HARD } DIFICULDADE;
typedef enum { NA = 0, UP, DOWN, LEFT, RIGHT } PROXIMA_ACCAO;
typedef enum { NO_COLISION, ALIMENTO, PAREDE, COBRA } TIPO_COLISAO;
typedef enum { FRACO = 0, MEDIO, BRUTO } TIPO_ALIMENTO;

typedef struct {
	int x, y;
} PONTO_2D;

typedef struct {
	//--> snake
	DIRECCAO_COBRA direccaoSnake;	// direcao da cobra [cabea] (importante para o update)
	int tamanhoSnake;				// tamanho actual da snake
	int growSnakeSize;				// quantas unidades e que a cobra ainda tem de crescer
	PONTO_2D alimento;				// posio do alimento
	TIPO_ALIMENTO tipo_alimento;	// 3 tipos de alimentos (FRACO, MEDIO, BRUTO)
	PONTO_2D *snake;				// vector com as posioes dos elementos da cobra. O primeiro  a cauda. O ultimo a cabea.
} SNAKE_WORLD;

typedef struct {
	DIFICULDADE nivel_dificuldade;						// nivel de dificuldade do jogo (afecta velocidade)
	char nomeJogador[TAM_NOME_JOGADOR];
	unsigned long int pontuacao;						// pontuao do jogador num determinado instante
	PROXIMA_ACCAO proximaAccao[MAX_ACCOES_PENDENTES];	// activada com as teclas do jogador
	bool gamePaused;									// true se o jogo estiver em pausa
	SNAKE_WORLD snakeWorld;								// Tudo o que diz respeito a cobra e aos elementos que estao no mundo da cobra
} ESTADO_DO_JOGO;

typedef struct {
	AUX_RGBImageRec *titulo_jogo;
	AUX_RGBImageRec *level_score;
	AUX_RGBImageRec *normal;
	AUX_RGBImageRec *hard;
	AUX_RGBImageRec *number[10];
	AUX_RGBImageRec *ring;
	AUX_RGBImageRec *pause;
} IMAGENS_JOGO;

class Jogo {
public:
	// Variveis Publicas

	// Contrudores
	Jogo();
	~Jogo();
	// Mtodos Publicos
	void initJogo(DIFICULDADE nd = NORMAL);
	void display_jogo();
	void interacao_jogo(unsigned char keyNormal, int keySpecial, int x, int y);
	void update_jogo();
	// Geters and Setters
	void setNivelDificuldade(DIFICULDADE nd);
	DIFICULDADE getNivelDificuldade();
	char *getNomeJogador();
	void setNomeJogador(char *nome);
	unsigned long int getPontuacao();
private:
	// Variveis Privadas
	ESTADO_DO_JOGO estadoDoJogo;
	IMAGENS_JOGO imagensJogo;
	// Mtodos Privados
		// draw
	void drawTabuleiro();
	void drawAlimentos();
	void drawSnake();
		// update
	void initSnake();
	void updateSnake();
	void geraAlimento();
	TIPO_COLISAO detectaColisao();
		// input
	void initPilhaAccao();
	void pushAccao(PROXIMA_ACCAO a);
	PROXIMA_ACCAO popAccao();
		// aux
	bool posAlimentoValida(PONTO_2D posAlimento);
	PONTO_2D *copyPonto2D(PONTO_2D *destino, PONTO_2D *origem);
	bool pontos2DEquals(PONTO_2D p1, PONTO_2D p2);
};

#endif