#include "includes.h"
extern Aplicacao *aplicacao;
extern Jogo *jogo;
extern HighScores *highScores;

//// Construtores
//
Menus::Menus(){
	// carrega as imagens do menu
	this->imagemFundo = auxDIBImageLoad("img/menu.dat");
}

Menus::~Menus(){}

//// Mtodos Publicos
//

void Menus::display_menuPrincipal(){
	int ww = aplicacao->getWindowWidth();
	int wh = aplicacao->getWindowHeight();

	this->displayImagemFundo();
	COR_FONTES_MENUS; // glColor3f(r, g, b)

	setFont("times roman", 24);
	drawStr(ww/2 - 80, wh/2 - 50  , "Main Menu");
	setFont("9x15", 0);
	drawStr(ww/2 - 110, wh/2 + 20 , "1   - Play Snake (Normal)");
	drawStr(ww/2 - 110, wh/2 + 40 , "2   - Play Snake (Hard)");
	drawStr(ww/2 - 110, wh/2 + 60 , "3   - HighScores");
	drawStr(ww/2 - 110, wh/2 + 80 , "4   - Help");
	drawStr(ww/2 - 110, wh/2 + 200, "Esc - Quit Game");
}

void Menus::interacao_menuPrincipal(unsigned char keyNormal, int keySpecial, int x, int y){
	if(keySpecial == -1){
		// Normal KeyBoard
		switch(keyNormal){
			case '1':
				jogo->initJogo();
				aplicacao->setEstadoApp(ESTADO_JOGO);
				break;
			case '2':
				jogo->initJogo(HARD);
				aplicacao->setEstadoApp(ESTADO_JOGO);
				break;
			case '3':
				aplicacao->setEstadoApp(ESTADO_HIGHSCORES);
				break;
			case '4':
				aplicacao->setEstadoApp(ESTADO_AJUDA);
				break;
			case 27: // Escape
				aplicacao->setEstadoApp(ESTADO_CREDITOS);
				break;
			default: return;
		}
	} else {
		// Special KeyBoard
		return;
	}
	glutPostRedisplay();
}

void Menus::display_gameOver(){
	int ww = aplicacao->getWindowWidth();
	int wh = aplicacao->getWindowHeight();

	this->displayImagemFundo();
	COR_FONTES_MENUS; // glColor3f(r, g, b)

	setFont("times roman", 24);
	drawStr(ww/2 - 80, wh/2 - 50  , "Game Over");
	setFont("9x15", 0);
	drawStr(ww/2 - 110, wh/2 + 20 , "Your Score is: %ld", jogo->getPontuacao());
	drawStr(ww/2 - 110, wh/2 + 50 , "Insert Your Name:");
	drawStr(ww/2 - 110, wh/2 + 70 , "> %s", jogo->getNomeJogador());
	
	drawStr(ww/2 - 110, wh/2 + 200, "Enter to Continue");
}

void Menus::interacao_gameOver(unsigned char keyNormal, int keySpecial, int x, int y){
	if(keySpecial == -1){
		// Normal KeyBoard
		char c = keyNormal;
	
		// Adiciona um caracter ao nome do jogador (aceita tb numeros por causa do meu amigo claudio k tem o nick -> m4ktub) eheh - eu penso no utilizador. incrivel :P
		if( ((c >= 'a') && (c <= 'z')) || ((c >= 'A') && (c <= 'Z')) || ((c >= '0') && (c <= '9')) || (c == ' ') ){
			jogo->setNomeJogador(this->adicionaUmCharNomeJogador(jogo->getNomeJogador(), c));
			glutPostRedisplay();
			return;
		}

		switch(keyNormal){
			case 13:	// Enter
				if((jogo->getNomeJogador()[0] != '\0') && (jogo->getPontuacao() != 0))
					highScores->updateScores(jogo->getNomeJogador(), jogo->getPontuacao());
				aplicacao->setEstadoApp(ESTADO_HIGHSCORES);
				break;
			case 8:		// Back Space
				jogo->setNomeJogador(this->apagaUmCharNomeJogador(jogo->getNomeJogador()));
				break;
			default: return;
		}
	} else {
		// Special KeyBoard
		return;
	}
	glutPostRedisplay();
}

void Menus::display_highScores(){
	int ww = aplicacao->getWindowWidth();
	int wh = aplicacao->getWindowHeight();
	int distancia, i;
	char strTmp[3];
	SCORE *scores;

	this->displayImagemFundo();
	COR_FONTES_MENUS; // glColor3f(r, g, b)

	setFont("times roman", 24);
	drawStr(ww/2 - 100, wh/2 - 50  , "High Scores");
	setFont("9x15", 0);
	if(jogo->getNivelDificuldade() == NORMAL){
		drawStr(ww/2 - 100, wh/2 + 20 , "<-  Normal  ->");
		scores = highScores->daListaHighScoresNormal();
	} else {
		drawStr(ww/2 - 100, wh/2 + 20 , "<-   Hard   ->");
		scores = highScores->daListaHighScoresHard();
	}

	for(i=0, distancia=60; i<MAX_NUM_SCORES; i++, distancia+=20){
		if(scores[i].nomeJogador[0] == '\0')
			continue;

		if(i+1>=10)
			strcpy(strTmp, " ");
		else
			strcpy(strTmp, "  ");
		drawStr(ww/2 - 110, wh/2 + distancia , "%d%s-> %ld , %s", i+1, strTmp, scores[i].pontuacao, scores[i].nomeJogador);
	}
	
	drawStr(ww/2 - 110, wh/2 + 280, "Any key - Main Menu");
}

void Menus::interacao_highScores(unsigned char keyNormal, int keySpecial, int x, int y){
	if(keySpecial == -1){
		// Normal KeyBoard
		aplicacao->setEstadoApp(ESTADO_MENU_PRINCIPAL);
	} else {
		// Special KeyBoard
		switch(keySpecial){
			case GLUT_KEY_LEFT:
			case GLUT_KEY_RIGHT:
				if(jogo->getNivelDificuldade() == NORMAL)
					jogo->setNivelDificuldade(HARD);
				else
					jogo->setNivelDificuldade(NORMAL);
				break;
			default:
				aplicacao->setEstadoApp(ESTADO_MENU_PRINCIPAL);
				break;
		}
	}
	glutPostRedisplay();
}

void Menus::display_ajuda(){
	int ww = aplicacao->getWindowWidth();
	int wh = aplicacao->getWindowHeight();

	this->displayImagemFundo();
	COR_FONTES_MENUS; // glColor3f(r, g, b)

	setFont("times roman", 24);
	drawStr(ww/2 - 40, wh/2 - 50   , "Help");
	setFont("9x15", 0);
	drawStr(ww/2 - 110, wh/2 + 20  , "Action:           Key:");
	drawStr(ww/2 - 110, wh/2 + 50  , "Up           -    up cursor");
	drawStr(ww/2 - 110, wh/2 + 70  , "Down         -    down cursor");
	drawStr(ww/2 - 110, wh/2 + 90  , "Left         -    left cursor");
	drawStr(ww/2 - 110, wh/2 + 110 , "Right        -    right cursor");
	drawStr(ww/2 - 110, wh/2 + 130 , "Pause Game   -    p");
	drawStr(ww/2 - 110, wh/2 + 150 , "Exit Game    -    Esc");

	drawStr(ww/2 - 110, wh/2 + 200,  "Any key - Main Menu");
}

void Menus::interacao_ajuda(unsigned char keyNormal, int keySpecial, int x, int y){
	if(keySpecial == -1){
		// Normal KeyBoard
		aplicacao->setEstadoApp(ESTADO_MENU_PRINCIPAL);
	} else {
		// Special KeyBoard
		aplicacao->setEstadoApp(ESTADO_MENU_PRINCIPAL);
	}
	glutPostRedisplay();
}

void Menus::display_creditos(){
	int ww = aplicacao->getWindowWidth();
	int wh = aplicacao->getWindowHeight();

	this->displayImagemFundo();
	COR_FONTES_MENUS; // glColor3f(r, g, b)

	setFont("times roman", 24);
	drawStr(ww/2 - 40, wh/2 - 50   , "About");
	setFont("9x15", 0);
	drawStr(ww/2 - 110, wh/2 + 20  , "Developed By:");
	drawStr(ww/2 - 110, wh/2 + 40  , "  Miguel Rosa Malato");
	drawStr(ww/2 - 110, wh/2 + 70  , "Special Thanks to:");
	drawStr(ww/2 - 110, wh/2 + 90  , "  Friends and Family");

	drawStr(ww/2 - 80, wh/2 + 200,  "Press Any Key");
}

void Menus::interacao_creditos(unsigned char keyNormal, int keySpecial, int x, int y){
	exit(0);	// sai do jogo quando se carrega nalguma tecla
}

//// Mtodos Privados
//

void Menus::displayImagemFundo(){
	int ww = aplicacao->getWindowWidth();
	int wh = aplicacao->getWindowHeight();

	glRasterPos2f(0, aplicacao->getWindowHeight());
	glDrawPixels(this->imagemFundo->sizeX, this->imagemFundo->sizeY, GL_RGB, GL_UNSIGNED_BYTE, this->imagemFundo->data);
	
	COR_FONTES_MENUS; // glColor3f(r, g, b)
	setFont("helvetica", 12);
	drawStr(ww - 220, wh - 20,  "@2005 MalatoSoft Corporation v1.0");
}

char *Menus::adicionaUmCharNomeJogador(char *nomeJogador, char c){
	int i;

	if(strlen(nomeJogador) < TAM_NOME_JOGADOR-1)
	{
		for(i=0; nomeJogador[i] != '\0'; i++)
			;
		nomeJogador[i] = c;
		nomeJogador[i+1] = '\0';
	}
	return nomeJogador;
}

char *Menus::apagaUmCharNomeJogador(char *nomeJogador){
	int i;

	if(*nomeJogador != '\0')
	{
		for(i=0; nomeJogador[i] != '\0'; i++)
			;
		nomeJogador[i-1] = '\0';
	}
	return nomeJogador;
}

//// Getters and Setters
//

